//
// GameX - Debug Class Code 
// 
// Copyright (C) 2002 Rama C. Hoetzlein
// 
// This software is released under the GameX GNU GPL 
// Open Source Liscense. See the GameX documentation included
// with this source code for terms of modification, 
// distribution and re-release. 
// 

#include <stdio.h>
#include <stdlib.h>

//*** Global Debugging (for ALL modules)
// The following define tells the debug include file that
// THIS module (Debug.cpp) should recieve the 
// global "debug" object to make debugging available to 
// all modules automatically. All other modules (except the 
// Debug module) will receive an external reference to this 
// global variable. (See debug.hpp)

#define DEBUG_GLOBAL

//*** Debugging Include

#include "gamex-debug.hpp"

//*** Debugging Class Code

Debugging::Debugging (void)
{
	out_file = NULL;
	Open ("debug.txt");
	fprintf (out_file, "* Debugging Output *\n");
}

Debugging::~Debugging (void)
{
	Close ();
	out_file = NULL;
}

void Debugging::Open (char *filename)
{
	if (out_file!=NULL) fclose (out_file);
	out_file = fopen (filename, "w+t");
	if (out_file==NULL) {
		printf ("DEBUGGER ERROR: Unable to open debug log file.\n");
	}
}

void Debugging::Close (void)
{
	if (out_file!=NULL)	fclose (out_file);
}

void Debugging::Output (char *msg1, char *msg2)
{
	fprintf (out_file, "%s  %s", msg1, msg2);
	fflush (out_file);	
}