#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <process.h>

#define GAMEX_WINDOWS
//#define GAMEX_FULLSCREEN
#define GAMEX_XSIZE		800
#define GAMEX_YSIZE		400

#include "gamex.hpp"

ImageX water[5];
ImageX ship_red;
ImageX ship_blue;
ImageX ship_rotated;
ImageX ship_shadow;
ImageX ship_splash;
ImageExt imgx;
int done;
int frame;
float fps;
float start;
float fin;
float x[300],y[300],dx[300],dy[300];

void initialize (void)
{
	int n;

	imgx.LoadTiff ("Images\\ship-red0009.tif", &ship_red);
	ship_red.ConvertFormat (IMG_HIGHCOLOR);	
	ship_red.ConvertAlphaToMask();
	//ship.ConvertAlphaToBlend ();

	imgx.LoadTiff ("Images\\ship-blue0009.tif", &ship_blue);
	ship_blue.ConvertFormat (IMG_HIGHCOLOR);	
	ship_blue.ConvertAlphaToMask();

	imgx.LoadTiff ("Images\\ship-splash.tif", &ship_splash);
	ship_splash.ConvertFormat (IMG_HIGHCOLOR);	
	//ship_blue.ConvertAlphaToMask();
	ship_splash.ConvertAlphaToBlend ();

	ship_rotated.Size (70, 70, IMG_HIGHCOLOR | IMG_ALPHA);

	imgx.LoadTiff ("Images\\ship-shadow.tif", &ship_shadow);
	ship_shadow.ConvertFormat (IMG_HIGHCOLOR);	
	//img.ConvertAlphaToMask();
	ship_shadow.ConvertAlphaToBlend ();
	
	imgx.LoadTiff ("Images\\ice.tif", &water[0]);
	water[0].ConvertFormat (IMG_HIGHCOLOR);

	/*imgx.LoadTiff ("Images\\water0000.tif", &water[0]);
	water[0].ConvertFormat (IMG_HIGHCOLOR);	
	imgx.LoadTiff ("Images\\water0001.tif", &water[1]);
	water[1].ConvertFormat (IMG_HIGHCOLOR);	
	imgx.LoadTiff ("Images\\water0002.tif", &water[2]);
	water[2].ConvertFormat (IMG_HIGHCOLOR);	
	imgx.LoadTiff ("Images\\water0003.tif", &water[3]);
	water[3].ConvertFormat (IMG_HIGHCOLOR);	
	imgx.LoadTiff ("Images\\water0004.tif", &water[4]);
	water[4].ConvertFormat (IMG_HIGHCOLOR);	
	imgx.LoadTiff ("Images\\water0005.tif", &water[5]);
	water[5].ConvertFormat (IMG_HIGHCOLOR);	*/

	done=0;
	frame=0;
	start = clock();
	srand((unsigned) time(NULL));
	for (n=0; n<50; n++) {
		x[n]=rand()*600 / RAND_MAX;
		y[n]=rand()*300 / RAND_MAX;
		dx[n]=2 - rand()*4/RAND_MAX;
		dy[n]=0.0;
	}
	//GameX.SetView (0, 0, 750, 480);
}


void main (void)
{
	char disp[30];
	int n, wobble_y, wobble_x;
	float s;
	int rndx, rndy;
	float ang;

	if (GameX.GetKeyDown(VK_LEFT))		dx[0]-=1;
	if (GameX.GetKeyDown(VK_RIGHT))		dx[0]+=1;
	if (GameX.GetKeyDown(VK_UP))		dy[0]-=1;
	if (GameX.GetKeyDown(VK_DOWN))		dy[0]+=1;
	
	x[0] += dx[0];
	y[0] += dy[0];
	s = fabs(dx[0])+fabs(dy[0]);

	GameX.DrawOpen ();	

		ang = atan2 (-dy[0], dx[0])/DEGtoRAD;
		
		GameX.DrawBackground (x[0], y[0], &water[0]);	
		
		wobble_x = -(s/10.0) + (rand()*(s/5.0))/RAND_MAX;
		wobble_y = (int) (sin(frame * (s/4.0) *DEGtoRAD)*15+20);
			
		ship_shadow.Rotate (&ship_rotated, ang-90, 0.45);
		GameX.DrawAlpha (200+5, 200-50+wobble_y, &ship_rotated);		
		ship_shadow.Rotate (&ship_rotated, ang-90, 0.45);
		GameX.DrawAlpha (500+200+5, 200-50+wobble_y, &ship_rotated);

		ship_splash.Rotate (&ship_rotated, ang, 0.45);
		for (n=1; n<(s/5.0); n+=2) {			
			GameX.DrawAdded (200+5-dx[0]*n, 200-50+wobble_y-dy[0]*n, &ship_rotated);
		}
		
		ship_red.Rotate (&ship_rotated, ang-90, 0.45);
		GameX.DrawMasked (200+wobble_x, 200-50-(wobble_y>>4), &ship_rotated);
		ship_blue.Rotate (&ship_rotated, ang-90, 0.45);
		GameX.DrawMasked (500+200+wobble_x, 200-50-(wobble_y>>4), &ship_rotated);		

		
		
	GameX.DrawClose ();

	if (frame % 10 == 0) {
		GameX.DrawColor (0,255,0);
		sprintf (disp, "fps: %f\n", fps);
		GameX.DrawText (20,10,disp);
		fin = clock();
		fps = (frame*CLOCKS_PER_SEC)/(fin-start);
	}
	frame++;		
	if (GameX.GetKey()==27) done=1;
	GameX.ViewUpdate ();
}
